package org.apache.bcel.classfile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ElementValue;

public class ArrayElementValue extends ElementValue {
  private final ElementValue[] elementValues;
  
  public ArrayElementValue(int type, ElementValue[] datums, ConstantPool cpool) {
    super(type, cpool);
    if (type != 91)
      throw new IllegalArgumentException("Only element values of type array can be built with this ctor - type specified: " + type); 
    this.elementValues = datums;
  }
  
  public void dump(DataOutputStream dos) throws IOException {
    dos.writeByte(getType());
    dos.writeShort(this.elementValues.length);
    for (ElementValue evalue : this.elementValues)
      evalue.dump(dos); 
  }
  
  public ElementValue[] getElementValuesArray() {
    return this.elementValues;
  }
  
  public int getElementValuesArraySize() {
    return this.elementValues.length;
  }
  
  public String stringifyValue() {
    StringBuilder sb = new StringBuilder();
    sb.append("[");
    for (int i = 0; i < this.elementValues.length; i++) {
      sb.append(this.elementValues[i].stringifyValue());
      if (i + 1 < this.elementValues.length)
        sb.append(","); 
    } 
    sb.append("]");
    return sb.toString();
  }
  
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("{");
    for (int i = 0; i < this.elementValues.length; i++) {
      sb.append(this.elementValues[i]);
      if (i + 1 < this.elementValues.length)
        sb.append(","); 
    } 
    sb.append("}");
    return sb.toString();
  }
}
